<script setup>
import { useGeneral } from "@/Composable/General";
import AuthenticatedLayout from "@/Layouts/AuthenticatedLayout.vue";
import { Link, useForm } from "@inertiajs/vue3";
import Pagination from "@/Components/PaginationLinks.vue";
const { deleteFunction } = useGeneral();
const { orders } = defineProps(['orders']);
import { usePage } from '@inertiajs/vue3'
import { computed } from "vue";
const page = usePage()

const user = computed(() => page.props.auth.user)
const form = useForm({
    row_per_page: null,
    searchData: null,
    selectedColumn: null,
    sortDirection: null,

});

const submit = () => {
    form.get(route('order.show'),
        {
            preserveState: true,
        });
}

const sortkey = (columnname, orderby) => {
    form.selectedColumn = columnname;
    form.sortDirection = orderby;
    submit();
}

const perPage = () => {
    form.row_per_page = document.getElementById("row_per_page").value;
    submit();
}

</script>
<template>

    <Head title="Index" />
    <AuthenticatedLayout>
        <template #header>
            <h2 class="font-semibold text-xl text-gray-800 leading-tight">orders</h2>
        </template>
        <div class="row">
            <div class="col-12">
                <div class="page-title-right">
                    <ol class="breadcrumb m-0">
                        <li class="breadcrumb-item">
                            <a href="javascript: void(0);">order</a>
                        </li>
                        <li class="breadcrumb-item active">Listing</li>
                    </ol>
                </div>
            </div>
        </div>
        <div class="container-fluid mt-3">
            <!-- Base Example -->
            <div class="accordion" id="default-accordion-example">
                <div class="accordion-item">
                    <h2 class="accordion-header" id="headingOne">
                        <button class="accordion-button" type="button" data-bs-toggle="collapse"
                            data-bs-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                            Serach filters
                        </button>
                    </h2>
                    <div id="collapseOne" class="accordion-collapse collapse show" aria-labelledby="headingOne"
                        data-bs-parent="#default-accordion-example">
                        <div class="accordion-body">
                            <div class="row">
                                <div class="col-sm-3">
                                    <input type="text" class="form-control" placeholder="Name Or Email"
                                        v-model="form.searchData" />
                                </div>
                            </div>
                        </div>
                        <div class="row m-2">
                            <div class="col-sm-3">
                                <button class="btn btn-primary" type="submit" name="Search"
                                    @click="submit">Search</button>
                                <Link :href="route('order.show')" class="btn border-success ms-2">Discard</Link>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
            <div class="row mt-3">
                <div class="col-lg-12">
                    <div class="card" id="tasksList">
                        <div class="card-header border-0">
                            <div class="d-flex align-items-center">
                                <h5 class="card-title mb-0 flex-grow-1">
                                    <div class="col-sm-1">
                                        <select name="row_per_page" id="row_per_page" class="form-control"
                                            @change="row_per_page">
                                            <option value="10">10</option>
                                            <option value="20">20</option>
                                            <option value="30">30</option>
                                            <option value="40">40</option>
                                            <option value="50">50</option>
                                        </select>
                                    </div>
                                </h5>
                            </div>
                        </div>

                        <!--end card-body-->
                        <div class="card-body">
                            <div class="table-responsive table-card mb-4">
                                <table class="table align-middle table-nowrap mb-0" id="tasksTable">
                                    <thead class="table-light text-muted">
                                        <tr>
                                            <th>
                                                ID
                                                <span @click="sortkey('id', 'desc')" class="float-end">
                                                    <i class="ri-arrow-down-s-fill "
                                                        :class="form.selectedColumn == 'id' && form.sortDirection == 'desc' ? 'text-danger' : 'text-secondary'"></i>
                                                </span>
                                                <span @click="sortkey('id', 'asc')" class="float-end">
                                                    <i class="ri-arrow-up-s-fill "
                                                        :class="form.selectedColumn == 'id' && form.sortDirection == 'asc' ? 'text-danger' : 'text-secondary'"></i>
                                                </span>
                                            </th>
                                            <th>User Name
                                            </th>
                                            <th>mobile_number</th>
                                            <th>address</th>
                                            <th>country</th>
                                            <th>status</th>
                                            <th>order_date</th>
                                            <th>total_amount</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    <tbody v-if="orders.length == 0">
                                        <tr class="text-center">
                                            <td colspan="8">
                                                No Data Found
                                            </td>
                                        </tr>
                                    </tbody>
                                          
                                    <tbody class="list form-check-all" v-else>
                                        <tr v-for="order in orders" :key="order.id">
                                            <td class="id">
                                                {{ order.id }}
                                            </td>
                                            <td>
                                                {{ order.user.name }}
                                            </td>
                                            <td>
                                                {{ order.mobile_number }}
                                            </td>
                                            <td>
                                                {{ order.address }}
                                            </td>
                                            <td>
                                                {{ order.country }}
                                            </td>
                                            <td class="priority">
                                                <span class="btn text-uppercase btn-sm"
                                                    :class="order.status == '1' ? 'btn-outline-secondary' : order.status == '2' ? 'btn-outline-success' : order.status == '3' ? 'btn-outline-warning' : order.status == '4' ? 'btn-outline-primary' : order.status == '5' ? 'btn-outline-info' : 'btn-outline-danger'">
                                                    {{ order.status == '1' ? 'Order' : order.status == '2' ? 'Accept' :
                                                        order.status == '3' ? 'Ready' : order.status == '4' ? 'Arriving' :
                                                    order.status == '5' ? 'Completed' : 'Reject' }}
                                                </span>
                                            </td>
                                            <td>
                                                {{ order.order_date }}
                                            </td>
                                            <td>
                                                {{ order.total_amount }}
                                            </td>
                                            <td>
                                                <Link :href="route('order.accept',order.ulid)" class="btn btn-primary btn-sm ms-2" v-if="order.status==3">Arriving</Link>
                                                <Link :href="route('order.accept',order.ulid)" class="btn btn-success btn-sm ms-2" v-if="order.status==4">Completed</Link>
                            <Link :href="route('deliveryBoy.confirmed', order.id)" v-if="user.role == 4 && order.inventory_id == 0">
                                <i class="ri-check-line fs-4 text-success ms-2 mt-2"></i>
                            </Link>
                                                <button class="border-0 bg-white"><i
                                                        class="ri-delete-bin-5-line fs-4 text-danger"
                                                        @click="deleteFunction(route('order.delete', order.ulid))"></i></button>
                                            </td>
                                        </tr>

                                       
                                    </tbody>
                                </table>
                            </div>

                        </div>
                        <!--end card-body-->
                    </div>
                    <!--end card-->
                </div>
                <!--end col-->
            </div>
        </div>


    </AuthenticatedLayout>
</template>